/*  ޷ Main Լ  */
function smallCalendar(yy, mm, dd) {
    var now = new Date(yy, mm - 1, dd);
    var year = now.getFullYear();
    var month = now.getMonth();
    //var monthName = getEnglishMonthName(month);
    var date = now.getDate();

    now = null;

    var firstDayInstance = new Date(year, month, 1);
    var firstDay = firstDayInstance.getDay() % 7;
    firstDayInstance = null;

    //    
    var days = getDayCount(month, year);
    //    
    var prevdays = 0;
    if (month == 0) prevdays = 31;
    else prevdays = getDayCount(month - 1, year);

    // ޷ html 
    drawSmallCalendar2(firstDay + 1, days, prevdays, date, month, year);
}

function smallCalendar_task(yy, mm, dd) {
    var now = new Date(yy, mm - 1, dd);
    var year = now.getFullYear();
    var month = now.getMonth();
    //var monthName = getEnglishMonthName(month);
    var date = now.getDate();

    now = null;

    var firstDayInstance = new Date(year, month, 1);
    var firstDay = firstDayInstance.getDay() % 7;
    firstDayInstance = null;

    //    
    var days = getDayCount(month, year);
    //    
    var prevdays = 0;
    if (month == 0) prevdays = 31;
    else prevdays = getDayCount(month - 1, year);

    // ޷ html 
    drawSmallCalendar_task(firstDay + 1, days, prevdays, date, month, year);
}

function smallCalendar_today() {
    var now = new Date();
    var year = now.getFullYear();
    var month = now.getMonth();
    //var monthName = getEnglishMonthName(month);
    var date = now.getDate();

    now = null;

    var firstDayInstance = new Date(year, month, 1);
    var firstDay = firstDayInstance.getDay() % 7;
    firstDayInstance = null;

    //    
    var days = getDayCount(month, year);
    //    
    var prevdays = 0;
    if (month == 0) prevdays = 31;
    else prevdays = getDayCount(month - 1, year);

    // ޷ html 
    drawSmallCalendar2(firstDay + 1, days, prevdays, date, month, year);
}

function largeCalendar() {
    var now = new Date();
    var year = now.getFullYear();
    var month = now.getMonth();
    var monthName = getMonthName(month);
    var date = now.getDate();

    now = null;

    var firstDayInstance = new Date(year, month, 1);
    var firstDay = firstDayInstance.getDay() % 7;
    firstDayInstance = null;

    //    
    var days = getDayCount(month, year);
    //    
    var prevdays = getDayCount(month - 1, year);

    // ޷ html 
    drawCalendar(firstDay + 1, days, date, monthName, year);
}

// Draw a week schedule (Week View - schedule_week.html)
function weekCalendar() {
	var now = new Date();
	var year = now.getFullYear();
	var month = now.getMonth(); //0 ~ 11
	var monthname = getEnglishMonthName(month);
	var date = now.getDate();
	var dayofweek = now.getDay() % 7; // 0 ~ 6 (Sun ~ Sat)
	var days = getDayCount(month, year);
	var prevdays = 0;
	var prevmonth = month - 1;
	var nextmonth = month + 1;
	var sunyear = year;
	var satyear = year;
	var sunmonth = monthname;
	var satmonth = monthname;
	var sundate = date - dayofweek;
	var satdate = date + (6 - dayofweek);	
	if (sundate <= 0) {
		if (month == 0) {
			prevdays = getDayCount(11, year - 1);
			prevmonth = 11;
			sunmonth = getEnglishMonthName(11);
			sunyear = year - 1;
		} else {
			prevdays = getDayCount(month - 1, year);
			sunmonth = getEnglishMonthName(month - 1);
		}
		sundate = prevdays + sundate;
	}
	else if (satdate > days) {
		if (month == 11) {
			satmonth = getEnglishMonthName(0);
			nextmonth = 0;
			satyear = year + 1;
		} else {
			satmonth = getEnglishMonthName(month + 1);
		}
		satdate = satdate - days;
	}
	var weekdays = new Array("SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT");
	var firstcell = "<b><font style=\"font-size: 9pt\">Week of "
							+ sunmonth + "&nbsp;" + sundate + ", " + sunyear + "&nbsp;to&nbsp;"
							+ satmonth + "&nbsp;" + satdate + ", " + satyear + "</font></b>";
	now = null;
	
	var timecellopen = "<td height=\"25\" width=\"50\" valign=\"top\" align=\"center\" bgcolor=\"#c0e2e2\">"
										+ "<font style=\"font-size: 9pt\">";
	var tdopen = "<td valign=\"center\" align=\"center\" bgcolor=\"#dff0f0\">"
							 + "<font style=\"font-size: 9pt\">";
	var todaytdopen = "<td valign=\"center\" align=\"center\" bgcolor=\"#f5f5f5\">"
							 + "<font style=\"font-size: 9pt\">";
	var i = 0;
	var daycount = 0;
	var cellopen = "<td height=\"20\" valign=\"bottom\" align=\"center\" bgcolor=\"white\" width=\"80\">"
							 + "<font style=\"font-size: 9pt\">";
	var todaycellopen = "<td valign=\"bottom\" align=\"center\" bgcolor=\"#f5f5f5\" width=\"80\">"
							 + "<font style=\"font-size: 9pt\">";
	var cellclose = "</font></td>";
	var html = "<table border=\"0\" bgcolor=\"gray\" cellspacing=\"1\">";
	html += "<tr><td height=\"18\" valign=\"bottom\" align=\"center\" colspan=\"8\" bgcolor=\"white\">" 
					+ firstcell + "</td></tr>"; //1st line
	html += "<tr>" + timecellopen + "&nbsp;" + cellclose;
	for (i == 0; i < 7; i++) { //filling date and week days - the 2nd line
		daycount = date - (dayofweek - i);
		if (daycount <= 0)
			html += cellopen + weekdays[i] + " " + (prevmonth+1) + "/" + (prevdays + daycount) + cellclose;
		else if (daycount > days) 
					html += cellopen + weekdays[i] + " " + (nextmonth+1) + "/" + (daycount - days) + cellclose;
		else {
			if (i == dayofweek)
				html += todaycellopen + weekdays[i] + " " + (month+1) + "/" + date + cellclose;
			else
				html += cellopen + weekdays[i] + " " + (month+1) + "/" + daycount + cellclose;
		}
	}
	html += "</tr>";

	var j = 0;
	var k = 0;
	while (j < 24) { //filling time cell - 3rd line ~ last line
		if (j == 0) html += "<tr>" + timecellopen + "12" + " am" + cellclose;
		else if (j < 12) html += "<tr>" + timecellopen + j + " am" + cellclose;
		else if (j == 12) html += "<tr>" + timecellopen + j + " pm" + cellclose;
		else html += "<tr>" + timecellopen + (j - 12) + " pm" + cellclose;
		for (k == 0; k < 7; k++) {
			if (k == dayofweek) html += todaytdopen + cellclose;
			else html += tdopen + cellclose;
		}
		html += "</tr>";
		j++;
		k = 0;
	}
	html += "</table>";
	document.write(html);
}

function monthCalendar() {
    var now = new Date();
    var year = now.getFullYear();
    var month = now.getMonth();
    var monthName = getEnglishMonthName(month);
    var date = now.getDate();

    now = null;

    var firstDayInstance = new Date(year, month, 1);
    var firstDay = firstDayInstance.getDay() % 7;
    firstDayInstance = null;

    //    
    var days = getDayCount(month, year);
    //    
    var prevdays = 0;
    if (month == 0) prevdays = 31;
    else prevdays = getDayCount(month - 1, year);

    // ޷ html 
    drawLargeCalendar(firstDay + 1, days, prevdays, date, monthName, year);
}

/*  ش   ϴ Լ  */
function getDayCount(month, year) {
    var arg = new Array(12);
    arg[0] = 31;    // 1
    arg[1] = (leapYear(year)) ? 29 : 28;    // 2
    arg[2] = 31;    // 3
    arg[3] = 30;    // 4
    arg[4] = 31;    // 5
    arg[5] = 30;    // 6
    arg[6] = 31;    // 7
    arg[7] = 31;    // 8
    arg[8] = 30;    // 9
    arg[9] = 31;    // 10
    arg[10] = 30;   // 11
    arg[11] = 31;   // 12

    return arg[month];
}

/*  ̸ true ƴϸ false return - 2   */
function leapYear(year) {
    if ((year % 4 == 0) && (year % 100 != 0) || (year % 400 == 0))
        return true;
    return false;
}

/*   ¥  returnϴ Լ */
function getMonthName(month) {
    var arg = new Array(12);

    arg[0]  = "1 ";
    arg[1]  = "2 ";
    arg[2]  = "3 ";
    arg[3]  = "4 ";
    arg[4]  = "5 ";
    arg[5]  = "6 ";
    arg[6]  = "7 ";
    arg[7]  = "8 ";
    arg[8]  = "9 ";
    arg[9]  = "10 ";
    arg[10] = "11 ";
    arg[11] = "12 ";

    return arg[month];
}

function getEnglishMonthName(month) {
    var arg = new Array(12);

    arg[0]  = "January";
    arg[1]  = "February";
    arg[2]  = "March";
    arg[3]  = "April";
    arg[4]  = "May";
    arg[5]  = "June";
    arg[6]  = "July";
    arg[7]  = "August";
    arg[8]  = "September";
    arg[9]  = "October";
    arg[10] = "November";
    arg[11] = "December";

    return arg[month];
}
/*   html ޷ ϴ Լ  */
function drawCalendar(firstDay, lastDate, date, monthName, year) {

    // ޷     Դϴ. ܼ  Ϸ ⸦ ϼ.
    var bgcolor = "#ccddff";
    var headerheight = 50;
    var headerbgcolor = "#ffddcc";
    var sunbgcolor = "#ffaa33";
    var satbgcolor = "#33aaff";
    var border = 1;
    var cellspacing = 4;
    var headercolor = "#6666ff";
    var headersize = "4";
    var colWidth = 60;
    var dayCellheight = 25;
    var daycolor = "#000000";
    var cellheight = 40;
    var todaycolor = "#ff6666";
    var todaybgcolor = "yellow";
    var fontFace = "Verdana";

    var openCol, openColSun, openColSat, closeCol;

    var text = "";
    text += '<center>';
    text += '<table border='+border+' cellspacing='+cellspacing+' bgcolor='+bgcolor+'>';
    text +=     '<th colspan=7 height='+headerheight+' + bgcolor='+headerbgcolor+'>';
    text +=         '<font face='+fontFace+' color='+headercolor+' size='+headersize+'>';
    text +=              year + ' ' + monthName;
    text +=         '</font>';
    text +=     '</th>';

    openCol = '<td width=' + colWidth + ' height=' + dayCellheight + '>';
    openColSun = '<td width='+colWidth+' height='+dayCellheight+' bgcolor='+sunbgcolor+'>';
    openColSat = '<td width='+colWidth+' height='+dayCellheight+' bgcolor='+satbgcolor+'>';
    openCol += '<font FACE=' + fontFace + 'color=' + daycolor + '>';
    closeCol = '</font></td>';

    var weekDay = new Array(7);
    weekDay[0] = "Ͽ";
    weekDay[1] = "";
    weekDay[2] = "ȭ";
    weekDay[3] = "";
    weekDay[4] = "";
    weekDay[5] = "ݿ";
    weekDay[6] = "";

    text += '<TR ALIGN="center" VALIGN="center">';
    for (var dayNum = 0; dayNum < 7; ++dayNum) {
        switch (dayNum%7) {
        case 0:
                text += openColSun + "<b>" + weekDay[dayNum] + "</b>" + closeCol;
                break;
        case 6:
                text += openColSat + "<b>" + weekDay[dayNum] + "</b>" + closeCol;
                break;
        default:
                text += openCol + "<b>" + weekDay[dayNum] + "</b>" + closeCol;
                break;
        }
    }
    text += '</tr>';

    var digit = 1;
    var curCell = 1;

    for (var row = 1; row <= Math.ceil((lastDate + firstDay - 1) / 7); ++row) {
        text += '<tr align="right" valign="center">';
        for (var col = 1; col <= 7; ++col) {
            if (digit > lastDate)
                break;
            if (curCell < firstDay) {
                text += '<td></td>';
                curCell++;
            } else {
                if (digit == date) {
                    text += '<td bgcolor=' + todaybgcolor + ' height=' + cellheight + '>';
                    text += '<b><font FACE=' + fontFace + ' color=' + todaycolor + '>';
                    text += digit;
                    text += '<br></font></b>';
                    text += '</td>';
                } else {
                    switch (col%7) {
                    case 1:
                        text += '<td height='+cellheight+' bgcolor='+sunbgcolor+'>'+digit+'</td>';
                        break;
                    case 0:
                        text += '<td height='+cellheight+' bgcolor='+satbgcolor+'>'+digit+'</td>';
                        break;
                    default:
                        text += '<td height=' + cellheight + '>' + digit + '</td>';
                        break;
                    }
                }
                digit++;
            }
        }
        text += '</tr>';
    }

    text += '</table>';
    text += '</center>';

    document.write(text);
}

function drawSmallCalendar(firstDay, lastDate, prevdays, date, monthName, year) {

    var bgcolor = "gray";
    var headerheight = 15;
    var headerbgcolor = "white";
    var sunbgcolor = "#ccddde";
    var satbgcolor = "#ccddde";
    var workdaybgcolor = "#ccddde";
    var border = "1";
    var cellspacing = "0";
    var headercolor = "black";
    var headersize = "2";
    var colWidth = 27;
    var dayCellheight = 22;
    var daycolor = "#696969";
    var daynamebgcolor = "#7caebe";
    var cellheight = 21;
    var todaycolor = "black";
    var satdaycolor = "blue";
    var sundaycolor = "red";
    var todaybgcolor = "powderblue";
    var otherbgcolor = "#cccccc";
    var fontFace = "Verdana";

    var openCol, openColSun, openColSat, closeCol;

    var text = "";
    text += '<center>';
    text += '<table cellpadding=0 border=0 cellspacing=1 bgcolor='+bgcolor+'>';
    text +=     '<th colspan=7 height='+headerheight+' + bgcolor='+headerbgcolor+'>';
    text +=         '<font face='+fontFace+' color='+headercolor+' size='+headersize+'>';
    text +=              monthName + ' ' + year;
    text +=         '</font>';
    text +=     '</th>';

    //openCol = '<td width=' + colWidth + ' height=' + dayCellheight + '>';
    openCol = '<td valign=center bgcolor=' + workdaybgcolor + '>';
    openColSun = '<td width='+colWidth+' height='+dayCellheight+' bgcolor='+sunbgcolor+'>';
    openColSat = '<td width='+colWidth+' height='+dayCellheight+' bgcolor='+satbgcolor+'>';
    openCol += '<font FACE=' + fontFace + 'color=' + daycolor + '>';
    openFirstCol = '<td width=' + colWidth + ' height=' + dayCellheight + ' bgcolor=' + daynamebgcolor+'>';
    closeCol = '</font></td>';

    var weekDay = new Array(7);
    weekDay[0] = "Su";
    weekDay[1] = "Mo";
    weekDay[2] = "Tu";
    weekDay[3] = "We";
    weekDay[4] = "Th";
    weekDay[5] = "Fr";
    weekDay[6] = "Sa";

    text += '<TR ALIGN="center" VALIGN="center">';
    for (var dayNum = 0; dayNum < 7; ++dayNum) {
        switch (dayNum%7) {
        case 0:
                text += openFirstCol + "<font size=2 FACE=" + fontFace + ">" + weekDay[dayNum] + closeCol;
                break;
        case 6:
                text += openFirstCol + "<font size=2 FACE=" + fontFace + ">" + weekDay[dayNum] + closeCol;
                break;
        default:
                text += openFirstCol + "<font size=2 FACE=" + fontFace + ">" + weekDay[dayNum] + closeCol;
                break;
        }
    }
    text += '</tr>';

    var digit = 1;
    var curCell = 1;
    var nextmonthday = 1;
    var lastCol = Math.ceil((lastDate + firstDay - 1)/7) * 7;

    for (var row = 1; row <= Math.ceil((lastDate + firstDay - 1) / 7); ++row) {
        text += '<tr align="center" valign="center">';
        for (var col = 1; col <= 7; ++col) {
            if (digit > lastDate) {
            		if (digit > lastCol)
            			break;
            		else {
            			text += '<td valign="center" height='+cellheight+' bgcolor='+otherbgcolor+
            			  '><font size="2" color=' + daycolor + ' FACE='+fontFace+'>'+nextmonthday+'</font></td>';
            			nextmonthday++;
            			digit++
            		}
            }            			
            else if (curCell < firstDay) {
                text += '<td valign="center" height='+cellheight+' bgcolor='+otherbgcolor+
                  '><font size="2" color=' + daycolor + ' FACE='+fontFace+'>';
                text += prevdays - firstDay + curCell + 1;
                text += '</font></td>';
                curCell++;
            } else {
                if (digit == date) {
                    text += '<td valign="center" bgcolor=' + todaybgcolor + ' height=' + cellheight + '>';
                    text += '<b><font size="2" FACE=' + fontFace + ' color=' + todaycolor + '>';
                    text += digit;
                    text += '</font></b>';
                    text += '</td>';
                } else {
                    switch (col%7) {
                    case 1:
                        text += '<td valign="center" height='+cellheight+' bgcolor='+satbgcolor+
                          '><font size="2" color=' + sundaycolor + ' FACE='+fontFace+'>'+digit+'</font></td>';
                        break;
                    case 0:
                        text += '<td valign="center" height='+cellheight+' bgcolor='+sunbgcolor+
                          '><font size="2" color=' + satdaycolor + ' FACE='+fontFace+'>'+digit+'</font></td>';
                        break;
                    default:
                        text += '<td valign="center" height='+cellheight+' bgcolor='+workdaybgcolor+
                          '><font size="2" color=' + daycolor + ' FACE='+fontFace+'>' + digit + '</font></td>';
                        break;
                    }
                }
                digit++;
            }
        }
        text += '</tr>';
    }

    text += '</table>';
    text += '</center>';

    document.write(text);
}

function drawSmallCalendar2(firstDay, lastDate, prevdays, date, month, year) {

    var text = "";
    var monthstr = ++month;
    var digit = 1;
    var curCell = 1;
    var nextmonthday = 1;
    var lastCol = Math.ceil((lastDate + firstDay - 1)/7) * 7;
    if (month < 10) monthstr = '0' + monthstr;

    for (var row = 1; row <= Math.ceil((lastDate + firstDay - 1) / 7); ++row) {
        text += '<tr align="center">';
        for (var col = 1; col <= 7; ++col) {
            if (digit > lastDate) {
            		if (digit > lastCol)
            			break;
            		else {
            			text += '<td width="23"><font color="#CCCCCC">'+nextmonthday+'</font></td>';
            			nextmonthday++;
            			digit++
            		}
            }            			
            else if (curCell < firstDay) {
                text += '<td width="23"><font color="#CCCCCC">';
                text += prevdays - firstDay + curCell + 1;
                text += '</font></td>';
                curCell++;
            } else {
                if (digit == date) {
                    text += '<td bgcolor="#009900" width="23"><b>';
                    text += '<a href="javascript:scheduleOf_right(\'' + year + monthstr;
                    if (digit < 10) text += '0';
                    text += digit + '\');"><font color="#FFFFFF">' + digit + '</font></a></b></td>';
                } else {
                    switch (col%7) {
                    case 1: //Sunday
                        text += '<td width="23">'
                        	+ '<a href="javascript:scheduleOf_right(\'' + year + monthstr;
                        if (digit < 10) text += '0';
                        text += digit + '\');"><font color="#9B5153">' + digit + '</font></a></td>';
                        break;
                    case 0: //Saturday
                        text += '<td width="23">'
                          + '<a href="javascript:scheduleOf_right(\'' + year + monthstr;
                        if (digit < 10) text += '0';
                        text += digit + '\');"><font color="#006699">' + digit + '</font></a></td>';
                        break;
                    default: //work day
                        text += '<td width="23">' + '<a href="javascript:scheduleOf_right(\'' + year + monthstr;
                        if (digit < 10) text += '0';
                        text += digit + '\');">' + digit + '</a></td>';
                        break;
                    }
                }
                digit++;
            }
        }
        text += '</tr>';
    }
    document.write(text);
}

function drawSmallCalendar_task(firstDay, lastDate, prevdays, date, month, year) {

    var text = "";
    var monthstr = ++month;
    var digit = 1;
    var curCell = 1;
    var nextmonthday = 1;
    var lastCol = Math.ceil((lastDate + firstDay - 1)/7) * 7;
    if (month < 10) monthstr = '0' + monthstr;

    for (var row = 1; row <= Math.ceil((lastDate + firstDay - 1) / 7); ++row) {
        text += '<tr align="center">';
        for (var col = 1; col <= 7; ++col) {
            if (digit > lastDate) {
            		if (digit > lastCol)
            			break;
            		else {
            			text += '<td width="23"><font color="#CCCCCC">'+nextmonthday+'</font></td>';
            			nextmonthday++;
            			digit++
            		}
            }            			
            else if (curCell < firstDay) {
                text += '<td width="23"><font color="#CCCCCC">';
                text += prevdays - firstDay + curCell + 1;
                text += '</font></td>';
                curCell++;
            } else {
                if (digit == date) {
                    text += '<td bgcolor="#009900" width="23"><b>';
                    text += '<a href="javascript:scheduleOf_right_task(\'' + year + monthstr;
                    if (digit < 10) text += '0';
                    text += digit + '\');"><font color="#FFFFFF">' + digit + '</font></a></b></td>';
                } else {
                    switch (col%7) {
                    case 1: //Sunday
                        text += '<td width="23">'
                        	+ '<a href="javascript:scheduleOf_right_task(\'' + year + monthstr;
                        if (digit < 10) text += '0';
                        text += digit + '\');"><font color="#9B5153">' + digit + '</font></a></td>';
                        break;
                    case 0: //Saturday
                        text += '<td width="23">'
                          + '<a href="javascript:scheduleOf_right_task(\'' + year + monthstr;
                        if (digit < 10) text += '0';
                        text += digit + '\');"><font color="#006699">' + digit + '</font></a></td>';
                        break;
                    default: //work day
                        text += '<td width="23">' + '<a href="javascript:scheduleOf_right_task(\'' + year + monthstr;
                        if (digit < 10) text += '0';
                        text += digit + '\');">' + digit + '</a></td>';
                        break;
                    }
                }
                digit++;
            }
        }
        text += '</tr>';
    }
    document.write(text);
}

function drawLargeCalendar(firstDay, lastDate, prevdays, date, monthName, year) {

    var bgcolor = "gray";
    var headerheight = 15;
    var headerbgcolor = "white";
    var sunbgcolor = "#ccddde";
    var satbgcolor = "#ccddde";
    var workdaybgcolor = "#ccddde";
    var border = "1";
    var cellspacing = "0";
    var headercolor = "black";
    var headersize = "2";
    var colWidth = 90;
    var dayCellheight = 15; //first line
    var daycolor = "#696969";
    var daynamebgcolor = "#7caebe";
    var cellheight = 70; //remaining lines
    var todaycolor = "black";
    var satdaycolor = "blue";
    var sundaycolor = "red";
    var todaybgcolor = "powderblue";
    var otherbgcolor = "#cccccc";
    var fontFace = "Verdana";
    var valign = "top";
    var align = "left";

    var openCol, openColSun, openColSat, closeCol;

    var text = "";
    text += '<center>';
    text += '<table cellpadding=0 border=0 cellspacing=1 bgcolor='+bgcolor+'>';
    text +=     '<th colspan=7 height='+headerheight+' + bgcolor='+headerbgcolor+'>';
    text +=         '<font face='+fontFace+' color='+headercolor+' size='+headersize+'>';
    text +=              monthName + ' ' + year;
    text +=         '</font>';
    text +=     '</th>';

    openCol = '<td valign=top align=left bgcolor=' + workdaybgcolor + ' width=' + colWidth + '>';
    openColSun = '<td valign=top align=left width='+colWidth+' height='+dayCellheight+' bgcolor='+sunbgcolor+'>';
    openColSat = '<td valign=top align=left width='+colWidth+' height='+dayCellheight+' bgcolor='+satbgcolor+'>';
    openCol += '<font FACE=' + fontFace + 'color=' + daycolor + '>';
    openFirstCol = '<td width=' + colWidth + ' height=' + dayCellheight + ' bgcolor=' + daynamebgcolor+'>';
    closeCol = '</font></td>';

    var weekDay = new Array(7);
    weekDay[0] = "Sunday";
    weekDay[1] = "Monday";
    weekDay[2] = "Tuesday";
    weekDay[3] = "Wednesday";
    weekDay[4] = "Thursday";
    weekDay[5] = "Friday";
    weekDay[6] = "Saturday";

    text += '<TR ALIGN="center" VALIGN="center">';
    for (var dayNum = 0; dayNum < 7; ++dayNum) {
        switch (dayNum%7) {
        case 0:
                text += openFirstCol + "<font size=2 FACE=" + fontFace + ">" + weekDay[dayNum] + closeCol;
                break;
        case 6:
                text += openFirstCol + "<font size=2 FACE=" + fontFace + ">" + weekDay[dayNum] + closeCol;
                break;
        default:
                text += openFirstCol + "<font size=2 FACE=" + fontFace + ">" + weekDay[dayNum] + closeCol;
                break;
        }
    }
    text += '</tr>';

    var digit = 1;
    var curCell = 1;
    var nextmonthday = 1;
    var lastCol = Math.ceil((lastDate + firstDay - 1)/7) * 7;

    for (var row = 1; row <= Math.ceil((lastDate + firstDay - 1) / 7); ++row) {
        text += '<tr align="' + align + '" valign="' + valign + '">';
        for (var col = 1; col <= 7; ++col) {
            if (digit > lastDate) {
            		if (digit > lastCol)
            			break;
            		else {
            			text += '<td valign="' + valign + '" height='+cellheight+' bgcolor='+otherbgcolor+
            			  '><font size="2" color=' + daycolor + ' FACE='+fontFace+'>'+nextmonthday+'</font></td>';
            			nextmonthday++;
            			digit++
            		}
            }            			
            else if (curCell < firstDay) {
                text += '<td valign="' + valign + '" height='+cellheight+' bgcolor='+otherbgcolor+
                  '><font size="2" color=' + daycolor + ' FACE='+fontFace+'>';
                text += prevdays - firstDay + curCell + 1;
                text += '</font></td>';
                curCell++;
            } else {
                if (digit == date) {
                    text += '<td valign="' + valign + '" bgcolor=' + todaybgcolor + ' height=' + cellheight + '>';
                    text += '<b><font size="2" FACE=' + fontFace + ' color=' + todaycolor + '>';
                    text += digit;
                    text += '</font></b>';
                    text += '</td>';
                } else {
                    switch (col%7) {
                    case 1:
                        text += '<td valign="' + valign + '" height='+cellheight+' bgcolor='+satbgcolor+
                          '><font size="2" color=' + sundaycolor + ' FACE='+fontFace+'>'+digit+'</font></td>';
                        break;
                    case 0:
                        text += '<td valign="' + valign + '" height='+cellheight+' bgcolor='+sunbgcolor+
                          '><font size="2" color=' + satdaycolor + ' FACE='+fontFace+'>'+digit+'</font></td>';
                        break;
                    default:
                        text += '<td valign="' + valign + '" height='+cellheight+' bgcolor='+workdaybgcolor+
                          '><font size="2" color=' + daycolor + ' FACE='+fontFace+'>' + digit + '</font></td>';
                        break;
                    }
                }
                digit++;
            }
        }
        text += '</tr>';
    }

    text += '</table>';
    text += '</center>';

    document.write(text);
}
